#ifndef _SPHERE_SOLVER_BC_TABLE_H_
#define _SPHERE_SOLVER_BC_TABLE_H_

#include "BC.h"
#include "MaterialTable.h"

class BCTable
{
public:
  BCTable();
  virtual ~BCTable();

public:  
  vector<BCvel*> m_OuterVBC;
  vector<BCp*>   m_OuterPBC;

  vector<BCvel*> m_InnerVBC;
  vector<BCp*>   m_InnerPBC;


protected:


public:
  bool ParseBCTable(MaterialTable *mt);
  bool print(FILE *fp);

protected:
  bool ParseOuterVBC(MaterialTable *mt);
  bool ParseOuterPBC(MaterialTable *mt);
};

#endif /*_SPHERE_SOLVER_BC_TABLE_H_*/

