      subroutine solbl(ni,nj,nk,vc,ipara,nID,
     1                 uvw,uvwo,bl,blo,bln,phin,ftime,
     2                 dt,dxinv,dyinv,dzinv,REAL_MIN
     2                )
c
      implicit none
c      include'com.h'
      include 'sklparaf.h'
      include 'param.h'

      integer ni,nj,nk,vc
c
      integer ipara,nID(6)
c
      real uvw     (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwo    (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bl      (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real blo     (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bln     (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phin    (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
c
      real ftime   (10)
c
      real dt
      real dxinv,dyinv,dzinv
      real REAL_MIN
c
c. solbl00.h
      real gxx,gyy,gzz,gxxo,gyyo,gzzo
      real gxymm,gxypm,gxymp,gxypp,gxymmo,gxypmo,gxympo,gxyppo
      real gyxmm,gyxpm,gyxmp,gyxpp,gyxmmo,gyxpmo,gyxmpo,gyxppo
      real gxzmm,gxzpm,gxzmp,gxzpp,gxzmmo,gxzpmo,gxzmpo,gxzppo
      real gzxmm,gzxpm,gzxmp,gzxpp,gzxmmo,gzxpmo,gzxmpo,gzxppo
      real gyzmm,gyzpm,gyzmp,gyzpp,gyzmmo,gyzpmo,gyzmpo,gyzppo
      real gzymm,gzypm,gzymp,gzypp,gzymmo,gzypmo,gzympo,gzyppo
      real blxx0,blyy0,blzz0
      real blxymm,blxypm,blxymp,blxypp,blxymmo,blxypmo,blxympo,blxyppo
      real blxzmm,blxzpm,blxzmp,blxzpp,blxzmmo,blxzpmo,blxzmpo,blxzppo
      real blyzmm,blyzpm,blyzmp,blyzpp,blyzmmo,blyzpmo,blyzmpo,blyzppo
      real blxxo0,blyyo0,blzzo0
      real u00,v00,w00
      real dfxm1,dfxm3,dfxm5,dfxp1,dfxp3,dfxp5
      real dfym1,dfym3,dfym5,dfyp1,dfyp3,dfyp5
      real dfzm1,dfzm3,dfzm5,dfzp1,dfzp3,dfzp5
      real adblxx,adblyy,adblzz,adblxxo,adblyyo,adblzzo
c
c. weno5.h
      real dfxm_1,dfxm_2,dfxm_3,dfxp_1,dfxp_2,dfxp_3
      real dfym_1,dfym_2,dfym_3,dfyp_1,dfyp_2,dfyp_3
      real dfzm_1,dfzm_2,dfzm_3,dfzp_1,dfzp_2,dfzp_3
      real sxm_1,sxm_2,sxm_3,sxp_1,sxp_2,sxp_3
      real sym_1,sym_2,sym_3,syp_1,syp_2,syp_3
      real szm_1,szm_2,szm_3,szp_1,szp_2,szp_3
      real axm_1,axm_2,axm_3,axp_1,axp_2,axp_3
      real aym_1,aym_2,aym_3,ayp_1,ayp_2,ayp_3
      real azm_1,azm_2,azm_3,azp_1,azp_2,azp_3
      real deninv_axm,deninv_aym,deninv_azm
      real deninv_axp,deninv_ayp,deninv_azp
      real wgxm_1,wgxm_2,wgxm_3,wgxp_1,wgxp_2,wgxp_3
      real wgym_1,wgym_2,wgym_3,wgyp_1,wgyp_2,wgyp_3
      real wgzm_1,wgzm_2,wgzm_3,wgzp_1,wgzp_2,wgzp_3
      real uab,vab,wab
      real uxm1,uxp1,vym1,vyp1,wzm1,wzp1
      real adxp1,adxm1,adyp1,adym1,adzp1,adzm1

c. solblxy.h
      real gxy,gyx,gxyo,gyxo
      real gxz,gzx,gxzo,gzxo
      real gyz,gzy,gyzo,gzyo
      real gxxmm,gxxpm,gxxmp,gxxpp,gxxmmo,gxxpmo,gxxmpo,gxxppo
      real gyymm,gyypm,gyymp,gyypp,gyymmo,gyypmo,gyympo,gyyppo
      real gzzmm,gzzpm,gzzmp,gzzpp,gzzmmo,gzzpmo,gzzmpo,gzzppo
      real blxy0,blyx0,blxz0,blzx0,blyz0,blzy0
      real blxyo0,blyxo0,blxzo0,blzxo0,blyzo0,blzyo0
      real adblxy,adblxyo
c
c. solblxz.h
      real adblxz,adblxzo

c. solblyz.h
      real adblyz,adblyzo
c
      real verysmall,d1_12,dx12inv,dy12inv,dz12inv
      real phis
c
      real*8 frt_gettime
      real*8 frt_spantime
      real*8 tim
c
      integer i,j,k
      integer ierr
c
ccc
ccc<modified left Cauchy-Green tensor
ccc

      verysmall=REAL_MIN      
      d1_12= 1.0d0/12.0d0
      dx12inv=dxinv*d1_12
      dy12inv=dyinv*d1_12
      dz12inv=dzinv*d1_12

      include 'solbl00.h'
      include 'solblxy.h'
      include 'solblxz.h'
      include 'solblyz.h'
      include 'bcbl.h'
c
      return
      end
