      subroutine tadv(vc,ni,nj,nk,
     1  uvw,uvwn,uvwo,phi,phin,phio,
     2  sg,sgn,sgo,bl,bln,blo)
c
      implicit none

cc subroutine arguments
      integer vc
      integer ni,nj,nk
      real uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwn(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real uvwo(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phi   (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phin  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real phio  (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sg  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sgn (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real sgo (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bl  (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real bln (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real blo (6,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
c
      call tadv2(uvwo,uvw ,3,ni,nj,nk,vc)
      call tadv2(uvw ,uvwn,3,ni,nj,nk,vc)
      call tadv2(phio,phi ,1,ni,nj,nk,vc)
      call tadv2(phi ,phin,1,ni,nj,nk,vc)
      call tadv2(sgo ,sg  ,6,ni,nj,nk,vc)
      call tadv2(sg  ,sgn ,6,ni,nj,nk,vc)
      call tadv2(blo ,bl  ,6,ni,nj,nk,vc)
      call tadv2(bl  ,bln ,6,ni,nj,nk,vc)

      return
      end
c
      subroutine tadv2(dst,src,nn,ni,nj,nk,vc)
      implicit none
      integer nn,ni,nj,nk,vc
      real dst(nn,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real src(nn,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      integer i,j,k,n

      do k=1-vc,nk+vc
      do j=1-vc,nj+vc
      do i=1-vc,ni+vc
      do n=1,nn
        dst(n,i,j,k) = src(n,i,j,k)
      enddo
      enddo
      enddo
      enddo
 
      return
      end 
c -------------------------------------------------------------


