//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  GetTime for Fortran
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include <sys/time.h>
#include <stdlib.h>

#define frtGetTime_ frtgettime_

extern "C" {
  double frtGetTime_()
  {
    timeval tv;
    gettimeofday(&tv, NULL);
    double t = 0.0;
    t += (double)tv.tv_sec;
    t += (double)tv.tv_usec * 1.0e-6;
    return t;
  }
};

