#ifndef _SPHERE_SOLVER_MATERIAL_H_
#define _SPHERE_SOLVER_MATERIAL_H_

#include "SklSolverBase.h"
#include "SklUtil.h"

#define D_MAX_MAT_PARAM  100
class Material
{
public:
  Material();
  virtual ~Material();

public:  
  char m_name[100];
  int  m_id;
  const char *m_type;
  const char *m_svx;
  double m_param[D_MAX_MAT_PARAM];
  bool   m_setp[D_MAX_MAT_PARAM];

protected:


public:
  bool ParseMat( const CfgElem *mat_elem );
  bool print(FILE *fp);
  bool ReadSVX( SklParaManager* ParaMngr, SklScalar3D<SKL_REAL> *dc_phi,
                int ni,int nj,int nk,int vc,int procGrp );

};

#endif /*_SPHERE_SOLVER_MATERIAL_H_*/

