#ifndef _SPHERE_SOLVER_MATERIAL_TABLE_H_
#define _SPHERE_SOLVER_MATERIAL_TABLE_H_

#include "Material.h"

class MaterialTable
{
public:
  MaterialTable();
  virtual ~MaterialTable();

public:  
  vector<Material*> m_material;


protected:


public:
  bool ParseMatTable();
  Material* Find(const char *mat_name);
  bool print(FILE *fp);
  bool ReadSVX( SklParaManager* ParaMngr, SklScalar3D<SKL_REAL> *dc_phi,
                int ni, int nj, int nk, int vc,int procGrp );

};

#endif /*_SPHERE_SOLVER_MATERIAL_TABLE_H_*/

