/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2008
 *
 */

#ifndef _SKL_SOLVER_SPH3D_DEFINE_H_
#define _SKL_SOLVER_SPH3D_DEFINE_H_

/* USER WRITE
   Please write macro definition here.
*/

// file output flag
#define NORMALOUT 0
#define FORCEDOUT 1

// domain direction
#define X_MINUS 0
#define Y_MINUS 1
#define Z_MINUS 2
#define X_PLUS  3
#define Y_PLUS  4
#define Z_PLUS  5

// poison equation
#define SOR   1
#define SOR4  2
#define SOR4O 3

// print title for LOG
#define PRINT_TITLE(_FP,_TITLE){ \
  if(_FP) fprintf( _FP, "\n" \
                        "******************************************************************\n" \
                        "*  %s\n" \
                        "******************************************************************\n" \
                      , _TITLE ); \
  if(_FP) fflush(_FP); \
}\

#endif // _SKL_SOLVER_SPH3D_DEFINE_H_

