c
c<j (wall)
c
      if( nID(Y_MINUS).lt.0 ) then 
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(bln)
        do k=1,nk
        do j=1,vc
        do i=1,ni
        bln(1,i, 1-j,k)=bln(1,i,     j,k)
        bln(2,i, 1-j,k)=bln(2,i,     j,k)
        bln(3,i, 1-j,k)=bln(3,i,     j,k)
        bln(5,i, 1-j,k)=bln(5,i,     j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,k)
!$OMP$ SHARED(bln)
        do k=1,nk
        do i=1,ni
        bln(4,i,   0,k)=0.0d0
        bln(4,i,  -1,k)=bln(4,i,   1,k)
        bln(4,i,  -2,k)=bln(4,i,   2,k)

        bln(6,i,   0,k)=0.0d0
        bln(6,i,  -1,k)=bln(6,i,   1,k)
        bln(6,i,  -2,k)=bln(6,i,   2,k)
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

      if( nID(Y_PLUS).lt.0 ) then
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(bln)
        do k=1,nk
        do j=1,vc
        do i=1,ni
        bln(1,i,nj+j,k)=bln(1,i,nj+1-j,k)
        bln(2,i,nj+j,k)=bln(2,i,nj+1-j,k)
        bln(3,i,nj+j,k)=bln(3,i,nj+1-j,k)
        bln(5,i,nj+j,k)=bln(5,i,nj+1-j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,k)
!$OMP$ SHARED(bln)
        do k=1,nk
        do i=1,ni
        bln(4,i,nj  ,k)=0.0d0
        bln(4,i,nj+1,k)=bln(4,i,nj-1,k)
        bln(4,i,nj+2,k)=bln(4,i,nj-2,k)
c        bln(4,i,nj+3,k)=bln(4,i,nj-3,k)

        bln(6,i,nj  ,k)=0.0d0
        bln(6,i,nj+1,k)=bln(6,i,nj-1,k)
        bln(6,i,nj+2,k)=bln(6,i,nj-2,k)
c        bln(6,i,nj+3,k)=bln(6,i,nj-3,k)
        enddo
        enddo
!$OMP END PARALLEL DO
      endif
c
c<i (periodic)
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(bln,X_DIR,PLUS2MINUS,vc,ierr)
        call SklCommPeriodicBndCell(bln,X_DIR,MINUS2PLUS,vc,ierr)
        ftime(3)=ftime(3)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(bln)
        do k=1,nk
        do j=1-vc,nj+vc
        do i=1,vc
        bln(1,1 -i,j,k)=bln(1,ni+1-i,j,k)
        bln(2,1 -i,j,k)=bln(2,ni+1-i,j,k)
        bln(3,1 -i,j,k)=bln(3,ni+1-i,j,k)
        bln(5,1 -i,j,k)=bln(5,ni+1-i,j,k)

        bln(1,ni+i,j,k)=bln(1,     i,j,k)
        bln(2,ni+i,j,k)=bln(2,     i,j,k)
        bln(3,ni+i,j,k)=bln(3,     i,j,k)
        bln(5,ni+i,j,k)=bln(5,     i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(bln)
        do k=1,nk
        do j=1-vc,nj+vc-1
        do i=1,vc
        bln(4,1 -i,j,k)=bln(4,ni+1-i,j,k)
        bln(6,1 -i,j,k)=bln(6,ni+1-i,j,k)

        bln(4,ni+i,j,k)=bln(4,     i,j,k)
        bln(6,ni+i,j,k)=bln(6,     i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<k (periodic)
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(bln,Z_DIR,PLUS2MINUS,vc,ierr)
        call SklCommPeriodicBndCell(bln,Z_DIR,MINUS2PLUS,vc,ierr)
        ftime(3)=ftime(3)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(bln)
        do k=1,vc
        do j=1-vc,nj+vc
        do i=1-vc,ni+vc
        bln(1,i,j,1 -k)=bln(1,i,j,nk+1-k)
        bln(2,i,j,1 -k)=bln(2,i,j,nk+1-k)
        bln(3,i,j,1 -k)=bln(3,i,j,nk+1-k)
        bln(5,i,j,1 -k)=bln(5,i,j,nk+1-k)

        bln(1,i,j,nk+k)=bln(1,i,j,     k)
        bln(2,i,j,nk+k)=bln(2,i,j,     k)
        bln(3,i,j,nk+k)=bln(3,i,j,     k)
        bln(5,i,j,nk+k)=bln(5,i,j,     k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO

!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(bln)
        do k=1,vc
        do j=1-vc,nj+vc-1
        do i=1-vc,ni+vc
        bln(4,i,j,1 -k)=bln(4,i,j,nk+1-k)
        bln(6,i,j,1 -k)=bln(6,i,j,nk+1-k)

        bln(4,i,j,nk+k)=bln(4,i,j,     k)
        bln(6,i,j,nk+k)=bln(6,i,j,     k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif
c
