c     
c<bounrady conditions

c
c<periodic i
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(p,X_DIR,PLUS2MINUS,vc,ierr)
        call SklCommPeriodicBndCell(p,X_DIR,MINUS2PLUS,vc,ierr)
        ftime(9)=ftime(9)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p)
        do k=1,nk
        do j=1,nj
        do i=1,1
        p(1 -i,j,k)=p(ni+1-i,j,k)
        p(ni+i,j,k)=p(     i,j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<wall j
c
      if( nID(Y_MINUS).lt.0 ) then
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p)
        do k=1,nk
        do j=1,1
        do i=0,ni+1
        p(i,1 -j,k)=p(i,     j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

      if( nID(Y_PLUS).lt.0 ) then
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p)
        do k=1,nk
        do j=1,1
        do i=0,ni+1
        p(i,nj+j,k)=p(i,nj+1-j,k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

c
c<periodic k
c
      if( ipara.eq.1 ) then
        tim=frt_gettime()
        call SklCommPeriodicBndCell(p,Z_DIR,PLUS2MINUS,vc,ierr)
        call SklCommPeriodicBndCell(p,Z_DIR,MINUS2PLUS,vc,ierr)
        ftime(9)=ftime(9)+frt_spantime(tim)
      else
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ SHARED(p)
        do k=1,1
        do j=0,nj+1
        do i=0,ni+1
        p(i,j,1 -k)=p(i,j,nk+1-k)
        p(i,j,nk+k)=p(i,j,     k)
        enddo
        enddo
        enddo
!$OMP END PARALLEL DO
      endif

