      subroutine cal_vg(flag,ni,nj,nk,vc,dx,dy,dz,uvw,outw)

      implicit none

      integer ni,nj,nk,vc
      integer flag
      real dx,dy,dz
      real uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real outw (1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer i,j,k
      integer n
      integer ox1,oy1,oz1,ox2,oy2,oz2
      real dd
      real dinv
      
      ox1=0
      oy1=0
      oz1=0
      ox2=0
      oy2=0
      oz2=0

      if( flag==1 )then !s11
        n=1
        ox2=-1
        dinv=1.0d0/dx
      elseif( flag==2 )then !s22
        n=2
        oy2=-1
        dinv=1.0d0/dy
      elseif( flag==3 )then !s33
        n=3
        oz2=-1
        dinv=1.0d0/dz
      elseif( flag==4 )then !d12
        n=1
        oy1=1
        dinv=1.0d0/dy
      elseif( flag==5 )then !d21        
        n=2
        ox1=1
        dinv=1.0d0/dx
      elseif( flag==6 )then !d13
        n=1
        oz1=1
        dinv=1.0d0/dz
      elseif( flag==7 )then !d31
        n=3
        ox1=1
        dinv=1.0d0/dx
      elseif( flag==8 )then !d23
        n=2
        oz1=1
        dinv=1.0d0/dz
      elseif( flag==9 )then !d32
        n=3
        oy1=1
        dinv=1.0d0/dy
      endif

     
      do k=1-vc+1,nk+vc-1
      do j=1-vc+1,nj+vc-1
      do i=1-vc+1,ni+vc-1

      dd = uvw(n,i+ox1,j+oy1,k+oz1)-uvw(n,i+ox2,j+oy2,k+oz2)
      outw(i,j,k) = dd*dinv

      enddo
      enddo
      enddo

      return
      end
