c--------+---------+---------+---------+---------+---------+---------+-----
      subroutine commface_wait(imax,jmax,kmax,vce,p,
     1                         recvib,recvjb,recvkb,buffsz,key,
     1                         istart,jstart,kstart)
c--------------------------------------------------------------------------
      implicit none
      include 'sklparaf.h'
c
      integer imax, jmax, kmax, vce
      integer istart,jstart,kstart
      real p
      dimension p(1-vce:imax+vce,1-vce:jmax+vce,1-vce:kmax+vce)
      integer buffsz(3)
      real recvib,recvjb,recvkb
      dimension  recvib(buffsz(1),2),
     1           recvjb(buffsz(2),2),
     1           recvkb(buffsz(3),2)
c
      integer key(6,2)
c
      integer i, j, k, isz
      integer ierr
c
cccccccccccccccccccccccccccc
c x-face
c   -x face send
      if( key(1,1).ge.0 ) then
        call SklWait(key(1,1),ierr)
      endif
c
c   +x face recv
      if( key(1,2).ge.0 ) then
        call SklWait(key(1,2),ierr)
        isz = 1
        do k=kstart,kmax,2
        do j=jstart,jmax,2
          p(imax+1, j, k) = recvib(isz,1)
          isz = isz + 1
        enddo
        enddo
      endif
c
c   +x face send
      if( key(2,1).ge.0 ) then
        call SklWait(key(2,1),ierr)
      endif
c
c   -x face recv
      if( key(2,2).ge.0 ) then
        call SklWait(key(2,2),ierr)
        isz = 1
        do k=kstart,kmax,2
        do j=jstart,jmax,2
          p(0,j,k) = recvib(isz,2)
          isz = isz + 1
        enddo
        enddo
      endif
c
cccccccccccccccccccccccccccc
c y-face
c   -y face send
      if( key(3,1).ge.0 ) then
        call SklWait(key(3,1),ierr)
      endif
c
c   +y face recv
      if( key(3,2).ge.0 ) then
        call SklWait(key(3,2),ierr)
        isz = 1
        do k=kstart,kmax,2
        do i=istart,imax,2
          p(i, jmax+1, k) = recvjb(isz,1)
          isz = isz + 1
        enddo
        enddo
      endif
c
c   +y face send
      if( key(4,1).ge.0 ) then
        call SklWait(key(4,1),ierr)
      endif
c
c   -y face recv
      if( key(4,2).ge.0 ) then
        call SklWait(key(4,2),ierr)
        isz = 1
        do k=kstart,kmax,2
        do i=istart,imax,2
          p(i,0,k) = recvjb(isz,2)
          isz = isz + 1
        enddo
        enddo
      endif
c
cccccccccccccccccccccccccccc
c z-face
c   -z face send
      if( key(5,1).ge.0 ) then
        call SklWait(key(5,1),ierr)
      endif
c
c   +z face recv
      if( key(5,2).ge.0 ) then
        call SklWait(key(5,2),ierr)
        isz = 1
        do j=jstart,jmax,2
        do i=istart,imax,2
          p(i, j, kmax+1) = recvkb(isz,1)
          isz = isz + 1
        enddo
        enddo
      endif
c
c   +z face send
      if( key(6,1).ge.0 ) then
        call SklWait(key(6,1),ierr)
      endif
c
c   -z face recv
      if( key(6,2).ge.0 ) then
        call SklWait(key(6,2),ierr)
        isz = 1
        do j=jstart,jmax,2
        do i=istart,imax,2
          p(i,j,0) = recvkb(isz,2)
          isz = isz + 1
        enddo
        enddo
      endif
c
      return
      end

