      subroutine initg(vc,ni,nj,nk,dx,dy,dz,
     2                 uvw,id,ng,nid,ug,vg,wg,xg,yg,zg)
c
      implicit none

cc subroutine arguments
      integer ni,nj,nk,vc
      integer ng
      integer nid(ng)
      integer id
      real dx,dy,dz
      real uvw (3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real ug(ng),  vg(ng), wg(ng)
      real xg(ng),  yg(ng), zg(ng)

cc local variables 
      real dxg,dzg,dyg

c<velocity (u)
      dxg=0.0d0
      dyg=0.5d0*dy
      dzg=0.5d0*dz
      call inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     +  uvw,1,ug,dxg,dyg,dzg,xg,yg,zg,nid,id)
c<velocity (v)
      dxg=0.5d0*dx
      dyg=0.0d0
      dzg=0.5d0*dz
      call inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     +  uvw,2,vg,dxg,dyg,dzg,xg,yg,zg,nid,id)
c<velocity (w)
      dxg=0.5d0*dx
      dyg=0.5d0*dy
      dzg=0.0d0
      call inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     +  uvw,3,wg,dxg,dyg,dzg,xg,yg,zg,nid,id)
c
      return
      end


