ccc 1st-order interporation 
ccc 3D

      subroutine inp1(vc,ni,nj,nk,ng,dx,dy,dz,
     1  tmp1,n,tmp2,dxg,dyg,dzg,xgg,ygg,zgg,nid,id)
c
      implicit none
      include 'sklparaf.h'

cc subroutine arguments
      integer n
      integer vc   
      integer ni,nj,nk
      integer ng
      integer nid(ng)
      integer id
      real dx,dy,dz
      real dxg,dyg,dzg
      real tmp1(3,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)
      real tmp2(ng)
      real xgg(ng)
      real ygg(ng)
      real zgg(ng)

cc local variables 
      integer i,j,k,l
      real dxinvv,dyinvv,dzinvv
      real xxg,yyg,zzg
      real xi,yj,zk
      real a1x,a1y,a1z
      real a2x,a2y,a2z
      real f111,f211,f121,f221,f112,f212,f122,f222
      real t3

      integer ih,jh,kh,ierr

      ih = 0
      jh = 0
      kh = 0
      if( id.gt.0 ) then
        call SklGetVoxelHeadIndex(BASE_PARAMANAGER,id,0,0,ih,ierr)
        call SklGetVoxelHeadIndex(BASE_PARAMANAGER,id,1,0,jh,ierr)
        call SklGetVoxelHeadIndex(BASE_PARAMANAGER,id,2,0,kh,ierr)
      endif

      dxinvv=1.0/dx
      dyinvv=1.0/dy
      dzinvv=1.0/dz

c<interporation
      do l=1,ng
      if( nid(l).eq.id+1 ) then
      xxg=xgg(l)+dxg
      yyg=ygg(l)+dyg
      zzg=zgg(l)+dzg
      xi=xxg*dxinvv
      yj=yyg*dyinvv
      zk=zzg*dzinvv
      i=int(xi)
      j=int(yj)
      k=int(zk)

      a2x=xi-dble(i)
      a2y=yj-dble(j)
      a2z=zk-dble(k)
      a1x=1.0d0-a2x
      a1y=1.0d0-a2y
      a1z=1.0d0-a2z
c
      i=i-ih
      j=j-jh
      k=k-kh
c
      f111=tmp1(n,i  ,j  ,k  )
      f211=tmp1(n,i+1,j  ,k  )
      f121=tmp1(n,i  ,j+1,k  )
      f221=tmp1(n,i+1,j+1,k  )
      f112=tmp1(n,i  ,j  ,k+1)
      f212=tmp1(n,i+1,j  ,k+1)
      f122=tmp1(n,i  ,j+1,k+1)
      f222=tmp1(n,i+1,j+1,k+1)


      t3=
     & + a1x*a1y*a1z*f111
     & + a2x*a1y*a1z*f211
     & + a1x*a2y*a1z*f121
     & + a2x*a2y*a1z*f221
     & + a1x*a1y*a2z*f112
     & + a2x*a1y*a2z*f212
     & + a1x*a2y*a2z*f122
     & + a2x*a2y*a2z*f222

      tmp2(l)=t3

      endif
c
      enddo
c
      return
      end


