c
c<sgxxn, sgyyn, sgzzn
c
!$OMP  PARALLEL DO
!$OMP$ DEFAULT(none)
!$OMP$ PRIVATE(i,j,k)
!$OMP$ PRIVATE(s2xxn,s2yyn,s2zzn)
!$OMP$ PRIVATE(blxxn0,blyyn0,blzzn0)
!$OMP$ PRIVATE(phis_root)
!$OMP$ PRIVATE(e2xxn,e2yyn,e2zzn)
!$OMP$ PRIVATE(tr)
!$OMP$ SHARED(uvwn)
!$OMP$ SHARED(dxinv,dyinv,dzinv)
!$OMP$ SHARED(bln)
!$OMP$ SHARED(phin)
!$OMP$ SHARED(sgn)
!$OMP$ SHARED(rnu00,gmd00,d1_3)
      do k=1,nk
      do j=1,nj
      do i=1,ni
c
      s2xxn=(-uvwn(1,i-1,j  ,k  )+uvwn(1,i,j,k))*dxinv*2.0d0
      s2yyn=(-uvwn(2,i  ,j-1,k  )+uvwn(2,i,j,k))*dyinv*2.0d0
      s2zzn=(-uvwn(3,i  ,j  ,k-1)+uvwn(3,i,j,k))*dzinv*2.0d0
c
      blxxn0=bln(1,i,j,k)
      blyyn0=bln(2,i,j,k)
      blzzn0=bln(3,i,j,k)
c
      phis_root=sqrt(phin(i,j,k))
c
      e2xxn=blxxn0*phis_root
      e2yyn=blyyn0*phis_root
      e2zzn=blzzn0*phis_root
c
         sgn(1,i,j,k)=
     1   s2xxn*rnu00
     1  +e2xxn*gmd00

         sgn(2,i,j,k)= 
     1   s2yyn*rnu00
     1  +e2yyn*gmd00

         sgn(3,i,j,k)= 
     1   s2zzn*rnu00
     1  +e2zzn*gmd00

      tr=(sgn(1,i,j,k)+sgn(2,i,j,k)+sgn(3,i,j,k))*d1_3
      sgn(1,i,j,k)=sgn(1,i,j,k)-tr
      sgn(2,i,j,k)=sgn(2,i,j,k)-tr 
      sgn(3,i,j,k)=sgn(3,i,j,k)-tr 
c
      tr=(s2xxn+s2yyn+s2zzn)*d1_3*rnu00
      sgn(1,i,j,k)=sgn(1,i,j,k)+tr
      sgn(2,i,j,k)=sgn(2,i,j,k)+tr 
      sgn(3,i,j,k)=sgn(3,i,j,k)+tr 
c
      enddo
      enddo
      enddo
!$OMP END PARALLEL DO

