c
c  get time
c
      real*8 function frt_gettime()
      real*8 frtGetTime
      frt_gettime = frtGetTime()
      return
      end
c
c  get span time
c
      real*8 function frt_spantime(before)
      real*8 before,frtGetTime
      frt_spantime = frtGetTime() - before
      end
c
c
c
      subroutine outvec(data,nn,ni,nj,nk,vc,lo,stp)
      implicit none
      integer nn,ni,nj,nk,vc,lo,stp
      real data(nn,1-vc:ni+vc,1-vc:nj+vc,1-vc:nk+vc)

      integer id,ierr,ipara,idx,jdx,kdx
      integer i,j,k,n
      integer i1,i2,j1,j2,k1,k2

      idx = 1
      jdx = 2
      kdx = 1

      call SklIsParallel(ipara)
      if( ipara.gt.0 ) then
        call SklGetMyID(id,0,ierr)
        write(lo+id) data
        close(lo+id)
      else
        i1 = 1-vc
        j1 = 1-vc
        k1 = 1-vc
        i2 = ni+vc
        j2 = nj+vc
        k2 = nk+vc
        if( idx.eq.2 ) i2 = (ni+1)/idx+vc
        if( jdx.eq.2 ) j2 = (nj+1)/jdx+vc
        if( kdx.eq.2 ) k2 = (nk+1)/kdx+vc
        write(lo) 
     1    ((((data(n,i,j,k),n=1,nn),i=i1,i2),j=j1,j2),k=k1,k2)
        close(lo)
        i1 = 1-vc
        j1 = 1-vc
        k1 = 1-vc
        if( idx.eq.2 ) i1 = (ni+1)/idx-vc+1
        if( jdx.eq.2 ) j1 = (nj+1)/jdx-vc+1
        if( kdx.eq.2 ) k1 = (nk+1)/kdx-vc+1
        i2 = ni+vc
        j2 = nj+vc
        k2 = nk+vc
        write(lo+1) 
     1    ((((data(n,i,j,k),n=1,nn),i=i1,i2),j=j1,j2),k=k1,k2)
        close(lo+1)
      endif 

      if( stp.eq.1 ) then
        call SklBarrier(0,ierr)
        call SklAbort(ierr)
        stop
      endif

      return
      end
