/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */

#include "SklFactorySPH3D.h"
#include "SklSolverSPH3D.h"

SklSolverBase* SklFactorySPH3D::CreateSolvObj(int sType)
{
  return (SklSolverBase*)new SklSolverSPH3D(sType);
}

void SklFactorySPH3D::DestorySolvObj(int sType, SklSolverBase* obj)
{
  SklSolverSPH3D* solv = 
           dynamic_cast<SklSolverSPH3D*>(obj);
  if( solv ) delete solv;
  else       delete obj;
}

