/*
 * SPHERE - Skeleton for PHysical and Engineering REsearch
 *
 * Copyright (c) RIKEN, Japan. All right reserved. 2004-2009
 *
 */

#ifndef _SKL_SOLVER_SPH3D_FACTORY_H_
#define _SKL_SOLVER_SPH3D_FACTORY_H_

#include "SklSolvFactoryBase.h"

class SklFactorySPH3D : public SklSolvFactoryBase {
public:
  SklFactorySPH3D(){;};
  virtual ~SklFactorySPH3D(){;};
  virtual SklSolverBase* CreateSolvObj(int sType);
  virtual void DestorySolvObj(int sType, SklSolverBase* obj);
};

#endif // _SKL_SOLVER_SPH3D_FACTORY_H_

